## onednn 3.10.2

=== src/gpu/CMakeLists.txt ===
#===============================================================================
# Copyright 2020-2025 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

file(GLOB SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/*.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    )

set(OBJ_LIB ${LIB_PACKAGE_NAME}_gpu)
add_library(${OBJ_LIB} OBJECT ${SOURCES})
set_property(GLOBAL APPEND PROPERTY DNNL_LIB_DEPS
    $<TARGET_OBJECTS:${OBJ_LIB}>)

add_subdirectory(generic)

if(DNNL_GPU_VENDOR STREQUAL "INTEL")
    include_directories_with_host_compiler(${CMAKE_CURRENT_SOURCE_DIR}/intel/jit/config/)

    set(ONEDNN_NGEN_DIR "${PROJECT_SOURCE_DIR}/third_party/ngen" CACHE PATH "Path to nGEN source code")
    add_definitions_with_host_compiler(-DNGEN_CONFIG)
    include_directories_with_host_compiler(${ONEDNN_NGEN_DIR})

    set(ONEDNN_GEMMSTONE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/intel/gemm/jit" CACHE PATH "Path to gemmstone source code")
    add_definitions_with_host_compiler(-DGEMMSTONE_CONFIG)
    include_directories_with_host_compiler(${ONEDNN_GEMMSTONE_DIR}/include)

    add_subdirectory(intel)
endif()

if(DNNL_GPU_VENDOR STREQUAL "NVIDIA")
    add_subdirectory(nvidia)
endif()

if(DNNL_GPU_VENDOR STREQUAL "AMD")
    add_subdirectory(amd)
endif()

# check if warn_unused_result can be used in an alias
set(COMPILER_ALLOWS_ALIAS_ATTRIBUTES_SOURCE
"
    typedef enum { dnnl_status_success = 0, } dnnl_status_t;
    using status_t __attribute__((warn_unused_result)) = dnnl_status_t;
    int main() { return 0; }
")
include(CheckCXXSourceCompiles)
set(CMAKE_REQUIRED_FLAGS "-Werror")
check_cxx_source_compiles("${COMPILER_ALLOWS_ALIAS_ATTRIBUTES_SOURCE}" COMPILER_ALLOWS_ALIAS_ATTRIBUTES)
unset(CMAKE_REQUIRED_FLAGS)

if(${COMPILER_ALLOWS_ALIAS_ATTRIBUTES})
    if(DNNL_GPU_VENDOR STREQUAL "INTEL")
        add_definitions_with_host_compiler(-DDNNL_STATUS_NODISCARD)
    endif()
endif()

if(DNNL_DISABLE_GPU_REF_KERNELS)
    message(STATUS "GPU Compute reference kernels are disabled")
else()
    message(STATUS "GPU Compute reference kernels are enabled")
endif()

=== tests/gtests/graph/unit/backend/dnnl/CMakeLists.txt ===
#===============================================================================
# Copyright 2021-2025 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

set(TEST_EXE test_graph_unit_dnnl)

# make gtest and library same definition for subgraph_visualizer_t
if(ONEDNN_ENABLE_GRAPH_DUMP)
    add_definitions_with_host_compiler(-DDNNL_ENABLE_GRAPH_DUMP)
endif()

FILE(GLOB DNNL_COMMON_TEST_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/test_dnnl_infer_shape_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_fusion_info_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_graph_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_insert_ops_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_internal_attrs_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_layout_id_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_layout_propagator_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_logical_tensor_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_memory_planning_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_op_schema_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_partition_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_thread_local_cache_cpu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_dnnl_utils_cpu.cpp
)

# op compile/execution need test on both CPU and GPU
FILE(GLOB DNNL_OP_EXECUTION_TEST_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/test_common.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_constant_cache.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_scratchpad.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_subgraph_pass.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_op_executable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_select.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_batch_norm.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_binary_op.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_bmm.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_compiled_partition.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_concat.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_convolution.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_convtranspose.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_dequantize.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_eltwise.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_group_norm.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_interpolate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_large_partition.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_layer_norm.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_matmul.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_mqa_decomp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_pool.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_prelu.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_quantize.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_reduce.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_reorder.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_sdp_decomp.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_softmax.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_typecast.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_pass.cpp
)

# SDPA/MQA decompose kernel only support OMP and THREADPOOL runtime.
if(NOT (DNNL_CPU_RUNTIME STREQUAL "OMP" OR DNNL_CPU_RUNTIME STREQUAL "THREADPOOL"))
    list(REMOVE_ITEM DNNL_OP_EXECUTION_TEST_SOURCES 
        "${CMAKE_CURRENT_SOURCE_DIR}/test_sdp_decomp.cpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/test_mqa_decomp.cpp"
    )
endif()

if(_ONEDNN_GRAPH_LAYOUT_DEBUG)
    file(GLOB FILES_REQUIRED_LAYOUT_DEBUG
        ${CMAKE_CURRENT_SOURCE_DIR}/test_layout_id.cpp
    )
    set_source_files_properties(${FILES_REQUIRED_LAYOUT_DEBUG}
        PROPERTIES COMPILE_FLAGS "-DDNNL_GRAPH_LAYOUT_DEBUG")
endif()

set(OBJ_LIB graph_unit_test_dnnl_backend)
add_library(${OBJ_LIB} OBJECT ${DNNL_OP_EXECUTION_TEST_SOURCES} ${DNNL_COMMON_TEST_SOURCES})
set_property(GLOBAL APPEND PROPERTY GRAPH_UNIT_TEST_DEPS $<TARGET_OBJECTS:${OBJ_LIB}>)

foreach(TEST_FILE ${DNNL_COMMON_TEST_SOURCES})
    get_filename_component(file_name ${TEST_FILE} NAME_WE)
    string(REPLACE "_cpu" "" file_name ${file_name})
    string(REPLACE "test_" "test_graph_unit_dnnl_" test_suite_name ${file_name})
    register_graph_test_suite(${test_suite_name}_cpu "${file_name}*")
endforeach()

foreach(TEST_FILE ${DNNL_OP_EXECUTION_TEST_SOURCES})
    get_filename_component(file_name ${TEST_FILE} NAME_WE)
    string(REPLACE "test_" "test_graph_unit_dnnl_" test_suite_name ${file_name})
    register_graph_test_suite(${test_suite_name} "${file_name}*")
endforeach()

=== debian/changelog ===
onednn (3.10.2-0ubuntu1~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2136925).

 -- Will French <will.french@canonical.com>  Wed, 14 Jan 2026 10:38:28 -0600

=== debian/control ===
Source: onednn
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: cmake,
               debhelper-compat (= 13),
               ninja-build,
               libtbb-dev,
               libspdlog-dev,
               libgtest-dev,
               libsimde-dev (>= 0.7.0),
               clang-dpcpp-21,
               libsycl-dev,
               libclang-dpcpp-common-21-dev,
               ocl-icd-opencl-dev
Standards-Version: 4.7.2
Homepage: https://github.com/oneapi-src/oneDNN
Rules-Requires-Root: no

Package: onednn-examples
Section: libdevel
Architecture: amd64
Depends: libdnnl-sycl-dev (= ${binary:Version}), ${misc:Depends}
Description: oneAPI Deep Neural Network (oneDNN) Examples
 oneAPI Deep Neural Network Library (oneDNN) is an open-source performance
 library for deep learning applications. The library includes basic building
 blocks for neural networks optimized for Intel Architecture Processors and
 Intel Processor Graphics.
 .
 oneDNN is intended for deep learning applications and framework developers
 interested in improving application performance on Intel CPUs and GPUs.
 .
 This package contains example programs for testing and development.

Package: libdnnl-sycl-dev
Section: libdevel
Architecture: amd64
Depends: libdnnl-sycl3 (= ${binary:Version}), ${misc:Depends}
Breaks: libmkldnn-dev, libdnnl-dev
Replaces: libmkldnn-dev, libdnnl-dev
Description: oneAPI Deep Neural Network (oneDNN) with SYCL Support (dev)
 oneAPI Deep Neural Network Library (oneDNN) is an open-source performance
 library for deep learning applications. The library includes basic building
 blocks for neural networks optimized for Intel Architecture Processors and
 Intel Processor Graphics.
 .
 oneDNN is intended for deep learning applications and framework developers
 interested in improving application performance on Intel CPUs and GPUs.
 .
 This package contains the header files, and symbol links to the shared object.
 Some are specific to the SYCL runtime for GPU support.

Package: libdnnl-sycl3
Section: libs
Architecture: amd64
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsycl8,
         libur-adapter-level-zero0,
         libur-adapter-opencl0,
Breaks: libmkldnn1, libdnnl3.6
Replaces: libmkldnn1, libdnnl3.6
Description: oneAPI Deep Neural Network (oneDNN) with SYCL support (lib)
 oneAPI Deep Neural Network Library (oneDNN) is an open-source performance
 library for deep learning applications. The library includes basic building
 blocks for neural networks optimized for Intel Architecture Processors and
 Intel Processor Graphics.
 .
 oneDNN is intended for deep learning applications and framework developers
 interested in improving application performance on Intel CPUs and GPUs.
 .
 This package contains the shared object built with SYCL support for running
 on GPUs.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS   = hardening=+all optimize=-lto
export DEB_CFLAGS_MAINT_APPEND   = -fdiagnostics-color=always #-fcolor-diagnostics #-Wall #-pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -fdiagnostics-color=always #-fcolor-diagnostics #-Wall #-pedantic
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
#export CLICOLOR_FORCE=ON

%:
	dh $@ -Scmake+ninja

# https://oneapi-src.github.io/oneDNN/dev_guide_build.html
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_COMPILER=clang++-dpcpp \
		-DCMAKE_C_COMPILER=clang-dpcpp \
		-DCMAKE_AR=/usr/lib/llvm-dpcpp-21/bin/llvm-ar \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DONEDNN_BUILD_TESTS=OFF \
		-DONEDNN_BUILD_EXAMPLES=OFF \
		-DONEDNN_BUILD_DOC=OFF \
		-DONEDNN_ARCH_OPT_FLAGS="" \
		-DONEDNN_CPU_RUNTIME=NONE \
		-DONEDNN_GPU_RUNTIME=SYCL \
		-DDNNL_LIBRARY_NAME=dnnl-sycl

execute_before_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: \.S'

execute_before_dh_auto_install:
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/mkldnn

override_dh_auto_test:
	# Intel GPU required for proper testing
	# Testing will occur outside of packaging process
	# using autopkgtest

override_dh_missing:
	dh_missing --fail-missing

override_dh_dwz:
	# dwz does not support DWARF 5 debug sections (e.g. .debug_addr)

=== debian/tests/control ===
Test-Command: install -D -m 0644 /usr/lib/onednn/examples/bnorm_u8_via_binary_postops.cpp examples/bnorm_u8_via_binary_postops.cpp; clang++-dpcpp -g -O2 -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer -ffile-prefix-map=/home/ubuntu/oneapi-packaging/onednn=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -fdebug-prefix-map=/home/ubuntu/oneapi-packaging/onednn=/usr/src/onednn-3.10.2-0ubuntu1~25.10~ppa3 -Wdate-time -D_FORTIFY_SOURCE=3 -fsycl -I /usr/lib/onednn/examples -I /usr/lib/onednn/examples/graph -Wl,-Bsymbolic-functions -Wl,-z,relro examples/bnorm_u8_via_binary_postops.cpp -ldnnl-sycl -lOpenCL -ltbb -o bnorm_u8_via_binary_postops_tester; ./bnorm_u8_via_binary_postops_tester gpu
Depends: @, onednn-examples, libtbb-dev, clang-dpcpp-21, libsycl-dev, libclang-dpcpp-common-21-dev, ocl-icd-opencl-dev
Restrictions: allow-stderr
Architecture: amd64
Features: test-name=clang++-dpcpp-bnorm_u8_via_binary_postops.cpp

Test-Command: install -D -m 0644 /usr/lib/onednn/examples/cnn_inference_f32.c examples/cnn_inference_f32.c; clang++-dpcpp -g -O2 -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer -ffile-prefix-map=/home/ubuntu/oneapi-packaging/onednn=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -fdebug-prefix-map=/home/ubuntu/oneapi-packaging/onednn=/usr/src/onednn-3.10.2-0ubuntu1~25.10~ppa3 -Wdate-time -D_FORTIFY_SOURCE=3 -fsycl -I /usr/lib/onednn/examples -I /usr/lib/onednn/examples/graph -Wl,-Bsymbolic-functions -Wl,-z,relro examples/cnn_inference_f32.c -ldnnl-sycl -lOpenCL -ltbb -o cnn_inference_f32_tester; ./cnn_inference_f32_tester gpu
Depends: @, onednn-examples, libtbb-dev, clang-dpcpp-21, libsycl-dev, libclang-dpcpp-common-21-dev, ocl-icd-opencl-dev
Restrictions: allow-stderr
Architecture: amd64
Features: test-name=clang++-dpcpp-cnn_inference_f32.c

Test-Command: install -D -m 0644 /usr/lib/onednn/examples/cnn_inference_f32.cpp examples/cnn_inference_f32.cpp; clang++-dpcpp -g -O2 -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer -ffile-prefix-map=/home/ubuntu/oneapi-packaging/onednn=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -fdebug-prefix-map=/home/ubuntu/oneapi-packaging/onednn=/usr/src/onednn-3.10.2-0ubuntu1~25.10~ppa3 -Wdate-time -D_FORTIFY_SOURCE=3 -fsycl -I /usr/lib/onednn/examples -I /usr/lib/onednn/examples/graph -Wl,-Bsymbolic-functions -Wl,-z,relro examples/cnn_inference_f32.cpp -ldnnl-sycl -lOpenCL -ltbb -o cnn_inference_f32_tester; ./cnn_inference_f32_tester gpu
Depends: @, onednn-examples, libtbb-dev, clang-dpcpp-21, libsycl-dev, libclang-dpcpp-common-21-dev, ocl-icd-opencl-dev
Restrictions: allow-stderr
Architecture: amd64
Features: test-name=clang++-dpcpp-cnn_inference_f32.cpp

=== debian/watch ===
Version: 5
Template: GitHub
Owner: uxlfoundation
Project: oneDNN
# skip (1) versions not starting with 'v' (2) -rc or -pc prereleases
MatchingPattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v((?:\d\.?)+)
